import org.eclipse.jdt.annotation.NonNull;
import org.eclipse.jdt.annotation.Nullable;


public class WikiExample {
	public class Supplier {
	    // this method requires much but delivers little
	    @Nullable String weakService (@NonNull String input, boolean selector) {
	        if (selector)
	            return input;
	        else
	            return null;
	    }
	    // this method requires nothing and delivers value
	    @NonNull String strongService (@Nullable String input) {
	        if (input == null)
	           return "";
	        else
	           return toUpperCase(input);
	    }
	}
	public class Client {
	    void main(boolean selector) {
	        Supplier supplier = new Supplier();
	        @Nullable String value = supplier.weakService("OK", selector);
	        @NonNull String result = supplier.strongService(value);
	        System.out.println(result.toLowerCase());
	    }
	}
	// wrapper for legacy method:
	@SuppressWarnings("nullcontract")
	static @NonNull String toUpperCase(@NonNull String input) {
		return input.toUpperCase();
	}
}
